module PackagecloudDebtools
  class File
    attr_accessor :checksum, :section, :priority, :filename, :dirname, :fullpath
    def initialize(checksum, filename, section, priority, dirname)
      @checksum = checksum
      @section = section
      @priority = priority
      @filename = filename
      @dirname = dirname
      @fullpath = ::File.join(@dirname, @filename)
    end

    def self.parse(line, dirname)
      if line =~ /^([a-z0-9A-Z]*)[\t\s]+([0-9]+)[\t\s]([a-z]+)\s([a-z]+)\s(.*)$/
        csum = Checksum.new('md5', $1, $2, $5, dirname)
        File.new(csum, csum.filename, $3, $4, dirname)
      else
        raise "#{line.strip} doesnt look like a file line!"
      end
    end

    def verify
      checksum.verify
    end

    def size
      checksum.size
    end

    def hash
      checksum.hash
    end
  end
end
